clear;  // Vorsicht - lscht alle Variablen
clc();  // aktuelles Plot-Window lschen
version='v6 2010-05-12'; 
author="www.gfai.de/~heinz";
printf('\n\n==========================================================\n\n');
printf('\n      WAV-Plotprogramm WAVs to GIF\n      Version %s\n',version);
printf('      non-profit freeware\n');
printf('       Copyrights: %s \n\n',author);
printf('      Ausfhrbar unter Scilab-3.1.1 \n');
printf('      Programm kann in irgendeinem Directory stehen \n');
printf('      Parameterfile *.PRA steuert Ausfhrung, \n');
printf('      in dessen Verzeichnis erscheinen alle Ergebnisfiles \n');
printf('      Temperaturfunktion *.BIN ist nutzbar\n');
printf('      *.PRA *.BIN und *.WAV sollten im gleichen Verzeichnis stehen\n');
printf('      Ablauf: \n');
printf('        1) WAVs als f-Funktionen einlesen und plotten \n');
printf('        2) g-Funktionen berechnen und plotten \n');
printf('        3) Files erzeugen \n\n');

// Inits

// globale Inits: Pra-file berschreibt diese, sofern dort vorhanden

      // Im *.pra-File sollte stehen z.B.:
      I = 0;  // fr evstr() erforderlich
      U = 0;  // fr evstr() erforderlich
      
      // Anzeigebereich im Plotbild:
      yo=-1.1;		// Anfang Wertebereich y
      yr=1.9;		// Ende Wertebereich y
      
      // Labelpositionen:
      xL=10;		// Label-Startposition x
      yL=1.8;		// Label-Startposition y
      yk=.3;   		// Labelabstand y
      plotwind=0;		// Graphic Window whlen


// =========== F U N K T I O N E N =============================================


// ____________________________________________________


  // Offsetbefreiung nullo
        // Die Funktion setzt AC-versetzte Zeitfunktionen wieder auf die Nullinie.
        // Dazu wird angenommen, da die Zeitfunktion innerhalb eines greren, 
        // sortierten Bereiches delta konstant mit Abweichung epsilon ist.

        function [out]=nullo(in)  // length(in) muss viel grer als deltat sein.
                    deltat=98;
                    i=1;
                    n=length(in);
                        if n <= 3*deltat then printf('   Warnung: length(in)=%i < 3*deltat=%i in Funktion nullo',n,3*deltat);
                        end;
                    eps=99;
                    ort=0;
                    insort=sort(in);              // Zeitfunktion sortieren
                    // clf;plot(insort);plot(in);
                      for i=1:(n-deltat) do;
                        delta=insort(i)-insort(i+deltat);
                          if delta < eps then;    // Suche nach Ort des minimalen Abstiegs
                          eps=delta; ort=i;
                          end;
                        nullpunkt=insort(ort);    // Hier ist unser gesuchter Nullpunkt
                      end;
                    [out] = (in)-nullpunkt;       // Verschieben der Zeitfunktion
                     printf('   Nullo: Ort=%i Nullpunkt=%i n=%i \n',ort,nullpunkt,n); 
                    // plot(out);
        endfunction;

// ____________________________________________________


  // Funktionswerte belassen - Identitt
        function [out] = equal(in);
            [out]=(in)
        endfunction;

// ____________________________________________________


  // Funktionswerte skalieren auf Anzeigebereich
        function [out] = scale(in,const);
            [out]=const .* in;
        endfunction;
                        
// ____________________________________________________


  // Funktionswerte verschieben im Anzeigebereich
        function [out] = shift(in,const);
            [out]=const + in;
        endfunction;
                        
// ____________________________________________________


  // Funktionswerte verschieben und skalieren im Anzeigebereich
        function [out] = zoom(in,scale,shift);
            [out]=scale .* in + shift;
        endfunction;
                        
// ____________________________________________________


  // Funktionswerte invertieren inv
        function [out] = invf(in);
            in = (-1) .* in;
            [out]=(in)
        endfunction;

// ____________________________________________________


  // Funktionswert skalieren fr Spannung U
  
        function [out] = Volt(in,cu)
            [out] = y .* cu;  // Spannungskalibrierung
        endfunction;
        
        
        function [out] = U(in,ccu);
             [out] = in .* yr ./ ccu  // Anpassung an Plottfenster
             //[out] = in ./ ccu  // Anpassung an Plottfenster
        endfunction;
        
// ____________________________________________________
  
  
  // Funktionswert skalieren fr Strom I
        
        function [out] = Amp(in,ci)
            [out] = y .* ci;  // Stromkalibrierung
        endfunction;
  
  
        function [out] = I(in,cci);
             [out] = in .* yr ./ cci  // Anpassung an Plottfenster
             //[out] = in ./ cci  // Anpassung an Plottfenster
        endfunction;

// ____________________________________________________


  // Offsetbehaftete Funktionswerte ins positive verschieben (u.U. vorher invertieren?!)
        function [out] = posef(in);
            inmin=min(in);    // inmin ist negativ
            [out]=in-inmin;   // doppelte Inversion
        endfunction;

// ____________________________________________________


  // Offsetbehaftete Funktionswerte ins negative verschieben (u.U. vorher invertieren?!)
        function [out] = negef(in);
            inmax=max(in);    // inmax ist positiv
            [out]=in-inmax;   // alles unter null
        endfunction;

// ____________________________________________________


  // Test-Plot. Farbe als String oder Zahl eingeben, evtl. vorher -->clf
        function [out] = plt(in,farbe);    // Redefining function plot ...
            // clf(); scf();
            xselect();   // Fenster hoch
            plot2d([],in,style=color(farbe));
            // legends(farbe,color(farbe),with_box=%f,opt="?");  // mit Maus platzieren!
            [out]=in;
            // Example: -->plt(f1,'blue'); p(f2);    // default-Farbe
        endfunction;

// ____________________________________________________


  // Normieren auf +1:-1  (symmetrisch)
        function [out] = norms(in);
                    [in]=(in);
                    maxw = max(in);   // Min und Max suchen
                    minw = min(in); 
                    // printf('\n  maxw=%i, minw=%i \n', maxw, minw);
                      if maxw > -minw then    // falls invertiert
                          maxw = 1 ./ maxw;
                          [out] = (in) .* maxw;   //
                          else
                          minw=1 ./minw;
                          [out] = (in) .* minw;   //
                      end;
        endfunction;
        
// ____________________________________________________

  // Normieren auf 0:1  (asymmetrisch)
        function [out] = norma(in);
                    [in]=(in);
                    maxw = max(in);   // Min und Max suchen                   
                    minw = min(in);
                    in = in - minw;   // auf Null schieben
                    maxw = max(in);   // Max erneut suchen
                    [out] = in ./ maxw;  // auf eins normieren
       endfunction;
        
// ____________________________________________________


  // Normieren auf 0:1 incl. null Offset
        function [out] = auto(in);
                    [in] = norma(in);    // Normierung
                    [in] = nullo(in);  // Null offset
                    [out] = in;
        endfunction;

// ____________________________________________________


  // float- ENERGY      E = P*dt = U I dt = F s [in Ws oder Nm]
        function [out] = E(uu,ii);
            [out] = abs(uu.*ii) ./ fs;   // U I dt = UI/fs
        endfunction;

// ____________________________________________________

 
  // float- POWER Berechnung der Momentanleistung in Watt
        function [out]=P(u,i);
            [out]=abs(u .* i);   //
        endfunction;

// ____________________________________________________

  // float- TEMPERATUR  aus Stefan/Boltzmann-Gesetz (Strahlungsleistung ~ Temperatur hoch vier)
        function [out] = TB(uu,ii,area);   
              // Temperatur in Kelvin = TB(Spannung in V, Strom in A, Flche in mm)
              // printf('\nTemperatur einer thermisch von einem schwarzen Krper abgestrahlten Leistung\n');
              // Stefan-Boltzmann-Gesetz: P = eps * sig * A * T^4  
              // T: Temperatur in Kelvin, A: Flche in m, P: Leistung in Watt
              sigma = 5.67D-8;      // Stefan-Boltzmann-Konstante in [W/(m^2 K^4)]
              emig = 0.5 // Emissionsgrad grauer Strahler
              // area = 1;  // Flche in mm
              // Test: tmp(1D6,459.27)
              // --> 300 Kelvin
              // Plasma: T=tmp(32,30*315)
              // --> 8495.2212 Kelvin
              // printf('Input:  (Area in mm, Power in Watt) \n');
              // printf('Output: Temperature in Kelvin    T = tmp(area,power) \n');
              mm = 1D-6;     // Normierung auf mm
              pow = uu .* ii; 
              //printf('\nsize(pow) = %i\n',size(pow))
              [out] = (pow ./ (emig * sigma * area * mm)) .^0.25;    // Temperatur in Kelvin
        endfunction;


// ____________________________________________________

  
// float- TEMPERATUR  nach Planckschem Strahlungsgesetz
        function [out] = TP(bb,rr,co);  // Temperatur = TP(blau, rot, Normierung)
            // bb: blau-Anteil (UV), rr: rot-Anteil (IR) - nicht vertauschen!
            // d.h. bb: kleine Wellenlnge, rr: groe Wellenlnge
            // Test ab hier kopieren //
            // bb=f1; rr=f2; clf;    // nur fr Test
            for i=1:length(rr); if rr(i)<0.1 then rr(i)=0.1; end, end;// keine Division durch Null
            for i=1:length(bb); if bb(i)<1e-3 then bb(i)=1e-3; end, end;// negative Strungen raus
            in = bb' ./ rr';   // Division versuchen
            // inmax = max(in); // Normieren
            // in = in ./ inmax; 
            //
            // Matrix-Format vierer=[grad,uv,ir,uvzuir]
            tempe = vierer(:,1); // Temperatur ist erste Spalte
            tempe = co .* tempe; // Temperaturkalibrierung
            rati  = vierer(:,4);  // Ratio ist letzte Spalte
            zweier = [rati'; tempe'];  // Zusammenbau der Temperaturfunktion fr interpln: x, f(x)
            n_ku = size(zweier), n_in = size(in)  // Tests
            // clf; plot2d(rati,tempe); // Temperaturkurve plotten
            //
            [out] = interpln(zweier,in)';   // out <== interpln([x;f(x)],in) 
            // zweier ist die Stammfunktion als Doppelreihe [x;f(x)], Matrix invertiert (')
            // clf; plot2d(in,out);
            // clf; plot(bb,'blue'); plot(rr,'red'); plot(in,'green'); plot(out,'black'); // Test bis hier
        endfunction;

// ____________________________________________________


// float- QUOTIENT function
        function [out] = Q(bb,rr,co);  // Druck = PP(blau, rot, Normierung)
            // Test ab hier kopieren //
            // bb=f1; rr=f2; clf;    // nur fr Test
            for i=1:length(rr); if rr(i)<0.1 then rr(i)=0.1; end, end;// keine Division durch Null
            for i=1:length(bb); if bb(i)<1e-3 then bb(i)=1e-3; end, end;// negative Strungen raus
            [out] = co .* bb' ./ rr';   // Division versuchen
            // inmax = max(in); // Normieren
            // in = in ./ inmax; 
        endfunction;


// ____________________________________________________


// float- Schwellwertfunktion mit Begrenzer
        function [out]=S(bb,rr,up,um,lip,lim);
              // Differenzbildung bb-rr
              // up, um: pos. und neg. Schwelle
              // lip, lim: pos. und neg. Limit
              // Beispiel: g5='S(f1,f2,0,-.1,1,0) purple scale(y,1) -'; 
              hyst=1;     // Vorsicht, Init
              out=lip;      // Vorsicht, Init
              uplus=up;  
              uminus=um; 
              limitplus=lip; 
              limitminus=lim; 
              n=length(rr);
              
              fd=bb-rr;
              
              for i=1:n;      //fr alle Samples i=1 bis n
                  if fd(i) > uplus then hyst=1;
                  end;
                  
                  if fd(i) < uminus then hyst=-1;
                  end;
                  
                  if hyst==1 then out(i)=limitplus;
                  end;
                  
                  if hyst==-1 then out(i)=limitminus;
                  end;
              end; //end for
              [out]=out;
        endfunction;



// ============= Ende Funktionen =============================================


 
 
// ============= P R O G R A M M =============================================
printf('\n================ wav2gif %s ==================\n\n\n',version);


// Parameterfile interaktiv laden
    filepath=xgetfile('*.pra',title='Parameter-File? ');
    //File-Inhalt auf Variablennamen laden:
    exec(filepath);  
    directory=dirname(filepath);  // Directory
    initfile=basename(filepath);  // Filename
    // einfacher: Komma hinter den Ausdruck setzen oder Semikolon wegnehmen
    //printf('Parameterfile: \n%s \n\n',filepath);
    printf('Parameter-File %s.pra wird geladen \n',initfile);
    printf('aus dem Verzeichnis:\n %s\n\n',directory);
    cd(directory);
    workdir=pwd();
    printf('Arbeitsverzeichnis ist:\n %s\n\n',workdir);
    // who_user;     // Anzeige der User-Variablen; 
    // who;          // Anzeige aller Variablen
    // whos;         // Anzeige in Langform; 
    
// Temperaturkennlinie laden (Ort steht in Parameterfile)
		iskurve = isdef('kurve');
		if iskurve then;		// wenn es eine Kurve gibt
	    	printf('Planck-Temperaturfunktion wird geladen von File:\n %s \n\n',kurve);
	    	load(kurve); // kurve ist in PAR-File definiert, liefert Matrix "vierer"
	    	// size(vierer); typeof(vierer); 
 		  	// Matrix-Format vierer=[grad,uv,ir,uvzuir]
		else; kurve = '(ohne Planck-Temperaturfunktion)';
		end;


printf('\n\n============ WAVs f lesen und plotten ===============\n\n');

// =============== DE RSTE SCHLAAPF =========================================

// wav-Files einlesen und plotten:

    scf(plotwind); 
    clf(plotwind);      // gewhltes Plotfenster lschen
     
// zur Berechnung f1...f8

    j=0;       // Index schiebt den Plotlabel hoch (wie oft wurde geplottet)
    plotf=0;   // Merkmal fr GIF-Name bilden
    csvkopf='';   // Init CSV/Excel Zeitfunktionsnamen
        

// anzf Zeitfunktionen lesen, anzf kommt aus PAR-File
for i=1:anzf; 

       // String lesen aus PAR
       f(i)='f'+string(i);        // i-te Zeitfunktion Ausdruck, Matrix nxm,    Test: f
       ff(i)='ff'+string(i);      // i-te Zeitfunktion Werte, Vektor m,         Test: ff
       f(i)=evstr(f(i));          // lese die Parameter auf String f(i),        Test: f(1)
       
       // Strings aus PAR-File zerlegen:
       printf('Aufgabe aus Parameter-File lesen: \nf%i = %s \n',i,f(i));
       tp=tokenpos(f(i));  // f(i)-String auseinanderpopeln
    // typ  =part(f(i),tp(1,1):tp(1,2));  // token -"- 
       name =part(f(i),tp(1,1):tp(1,2));  // token -"-
       farbe=part(f(i),tp(2,1):tp(2,2));  // token -"-
       nega =part(f(i),tp(3,1):tp(3,2));  // token -"-
       nrm  =part(f(i),tp(4,1):tp(4,2));  // token -"-
       plo  =part(f(i),tp(5,1):tp(5,2));  // token -"-
       printf(' String-Zerlegung: \n   f%i ~ %s\n   %s\n   %s\n   %s\n   Plot? %s\n',i,name,farbe,nega,nrm,plo);
 
       // Wav-Filename basteln
       filnam=source+'_'+name+'.wav';
       wavname=directory+'\'+filnam;
       
       // Excel-Spaltenberschriften generieren (CSV-Format)
       if i==1, csvkopf = name;         // Init
       else
       csvkopf= csvkopf +', '+name;     // ..., nchste Spalte, ...
       end;
       
       // Wav-File lesen
       printf('   laden: %s \n',filnam);
       [y,fs,bits]=wavread(wavname); //wav lesen auf y; samplerate fs integer; bits integer;
       printf('   %i-te Zeitfunktion gelesen mit Sample-Rate %i Hz, %i Bit/Sample \n',i,fs,bits);
       fs=fs; 
       
       // Start und Stop Samples bestimmen
          // tstart in Millisekunden, start in Samples
          // tdelta in Millisekunden, delta in Samples
          
          startdef = isdef('start');
          if startdef == %F then
          start = int(tstart*fs/1e3);   // Ermittlung der Samples fr Start x-Achse, t in Millisekunden
          end;
          
          deltadef = isdef('delta');
          if deltadef == %F then
          delta = int(tdelta*fs/1e3);   // Plotbereich x
          end;
          
          if delta < 256 then delta = 256;   // nur falls zu klein angesetzt
          end;

       printf('   Zeitfunktion Start Sample %i \n',start);
       printf('   Lnge der Zeitfunktion delta = %i Samples\n',delta);
       // printf('   delta = %i Samples \n',delta);
       stop=start+delta-1;           // Plotende x
       

       // Wav-File beschnippeln
       y=y(start:stop);       // Zeitfunktion zurechtschneiden

       
       // Init der Labels       
       xo=0; xr=delta;    // Plotbildausschnitt fixieren
       xoo=xL;      // alt: xoo=xo+xL;
       yoo=yL;      // alt: yoo=yo+yL;
       
       // Zeitfunktion entsprechend Token ausfhren
       y=evstr(nega);              // Ausfhrung des Tokens nega

       // Zeitfunktion entsprechend Token ausfhren
       y=evstr(nrm);               // Ausfhrung des Tokens nrm
       
       // aus Wav-Files eine Matrix bilden fr CSV
       if i==1           // init, erste Spalte
       csv = y;          
       else
       csv=[csv y];      // Matrix append_horizontal = [a a]  
       end;

       // Files indiziert ablegen, wird fr g(i) gebraucht
       select i       // wird fr Berechnung gebraucht
           case 1 then f1=y; tit='f1';
           case 2 then f2=y; tit='f2';
           case 3 then f3=y; tit='f3'; 
           case 4 then f4=y; tit='f4';
           case 5 then f5=y; tit='f5';
           case 6 then f6=y; tit='f6';
           case 7 then f7=y; tit='f7';
           case 8 then f8=y; tit='f8';
           else fmax=i;
       end;

       // Plot-Iteration
       xselect();                 // Fenster top
       select plo case 'yes' then // nur wenn letzter Parameter 'yes' ist
           plot2d([],y,style=color(farbe),rect=[xo,yo,xr,yr]);
           xleg=xoo;          // Legende
           yleg=yoo + yk * j; // plus Verschiebung nach oben
           printf('   Koordinaten des Plotlabels: xleg = %g, yleg = %g, j = %i \n\n',xleg,yleg, j);
           j=j+1;									    // Schleifenzhler erhhen
           plotf=i;   // Merkmal fr GIF-Name bilden
           legends(tit+'='+name,color(farbe),with_box=%f,opt=[xleg,yleg]); 
           // mit Maus platzieren: opt="?" statt xleg,yleg
           // printf('\n   BITTE MIT DER MAUS IN DIE GRAFIK KLICKEN!\n\n'); 
       end;
       
             
end; // der i-Schleife
  
// =============== GEMMAR INDINGE NAUS AUS DR FF SCHLAAPF============================





printf('\n\n============= Funktionen g berechnen und plotten ============\n\n');

    
// =============== UN NEI INDE ZWAHTE SCHLAAPF FOR DE GEJH =============================

// Berechnung g1...g8


// g-Zeitfunktionen berechnen

      // Sample-Intervallbreite wird fr Energieberechnung gebraucht:
          dt = 1/fs;   // fs: Samplerate
          fs=fs;
          // n = anzg;    // anz Zeitfunktionen lesen, anz kommt aus PRA-File
          plotg = 0;   // Plotzyklen mitzhlen fr GIF-Name
          
if anzg ~= 0 then    // Test, ob anzg ungleich Null war
    
  for i=1:anzg;    // Zeitfunktionen g(i) nacheinander abarbeiten

       // String lesen aus PAR
         g(i)='g'+string(i);      // i-te Zeitfunktion = g1, g2, ... hernehmen
         g(i)=evstr(g(i));        // lese parameter auf String g(i)
              
       // Strings aus PAR-File zerlegen, gi-String auseinanderpopeln
         printf('\nAufgabe aus Parameter-File lesen:\n   g%i=%s \n',i,g(i));
         tp=tokenpos(g(i));         // Matrix der Tokenpositionen
         // typ  =part(g(i),tp(1,1):tp(1,2));  // token -"-
         name =part(g(i),tp(1,1):tp(1,2));  // token -"-
         farbe=part(g(i),tp(2,1):tp(2,2));  // token -"-
         nrm  =part(g(i),tp(3,1):tp(3,2));  // token -"-
         plo  =part(g(i),tp(4,1):tp(4,2));  // token -"-

       // Token ausfhren name
         printf('   Berechnung von \n   g%i = %s',i,name);
         y=evstr(name);               // Ausfhrung der Funktion (name)
         printf('\n   Format der Zeitfunktion: %i x %i\n',size(y),size(y'));

       // Token ausfhren nrm
         y=evstr(nrm);                // Ausfhrung der Funktion nrm
         
       nameohnekomma = part(name,[1,2]);     // nur die ersten zwei Buchstaben nehmen       
       
       // Namens-String fr Excel-Beschriftung generieren
       // csvkopf= csvkopf +', '+'g'+string(i);            
       csvkopf= csvkopf +', '+ nameohnekomma;     
       
       // aus Wav-Files eine Matrix bilden fr CSV
       csv=[csv y];      // append_horizontal = [a a]  
              
       // Namen bilden
       select i     // fr Tests
           case 1 then g1=y;
           case 2 then g2=y;
           case 3 then g3=y;
           case 4 then g4=y;
           case 5 then g5=y;
           case 6 then g6=y;
           case 7 then g7=y;
           case 8 then g8=y;
           else gmax=i;
       end;


 
       // Plotten
       select plo case 'yes' then 
           xselect(); // Fenster hoch
           plot2d([],y,style=color(farbe),rect=[xo,yo,xr,yr]);
           xleg=xoo;        // x-Position der Legende
           yleg=yoo+yk*j;   // y-Position der Legende
           printf('   Koordinaten des Plotlabels: xleg = %g, yleg = %g, i = %g \n',xleg,yleg,i);
           j=j+1;           
           plotg=i;   // Merkmal fr GIF-Namen bilden
           // printf('\n   BITTE MIT DER MAUS IN DIE GRAFIK KLICKEN!\n\n');
           legends(name,color(farbe),with_box=%f,opt=[xleg,yleg]);  
           // mit Maus platzieren: opt="?", 
           // sonstige Optinen: "ur", "ul", "lr", "ll" zeichnen alle Legenden bereinander
           // Option opt="[x,y]" fr definierte Platzierung
       end;

       
       // gstr=list(g(i),name,farbe,nega,nrm,plo);
       // printf('Zerlegung in Teile: \n f%i == %s\n %s\n %s\n %s\n %s\n %s\n \n',i,g,name,farbe,nega,nrm,plo);
       
  end;    // Ende der for i-Schleife
  
 else;    // if anzg == 0
 g= " ";  // kein g zu drucken
end;      // if anzg == 0

// =============== DE SCHLAAPFN SEI FEI ITZE ZE END! =================================

 printf('\n\n================ Plot beschriften ================\n\n');
		
    printf('   %s\n',f);		// f ist Matrix!
    printf('   %s\n',g);		// g ist Matrix!
    signum='  '+author;

 printf('\n\n================ Ausgaben ================\n\n');

// Plot beschriften
    plotfile=initfile;
    // plotfile=initfile+'_'+date();
    // plotfile=initfile+'_f'+string(plotf)+'_g'+string(plotg);
    titel1=titel+', fs = '+string(fs)+' Hz, '+plotfile;  // Titel kommen aus dem *.pra-File
    titel2=source+'.chl;  '+parameter+', Startsample '+string(start)+', '+signum;
    xtitle([titel1 titel2],'Sample','rel.');    // Header des Plotbildes

// GIF machen
    xs2gif(0,plotfile+'.gif');  // Gif von Fenster #0
    printf('Arbeitsverzeichnis: \n %s \n',workdir);
    printf('\nPlot gespeichert als Bild: \n %s.gif \n',plotfile);
        
// CSV-File der Zeitfunktionen in Excel-Format CSV (Comma Separated Values)
     csvname = plotfile+'.csv';
     len=1; anz=1;               // formales Init
     [len,anz] = size(csv);      // Matrix-Size ermitteln: Zeilen len, Spalten anz

     
     // Excel-CSV-File anlegen
     fd=mopen(csvname,'w+');  // try to open CSV-File (Error: file is opened by a different application)
     mfprintf(fd,'Excel-File im Format CSV (Comma Separated Values)\n');
     mfprintf(fd,'Parameterfile \t'+initfile+'.pra\n');
     mfprintf(fd,'Plotfile \t'+plotfile+'.gif\n');
     mfprintf(fd,'Directory \n'+directory+'\n');
     mfprintf(fd,author);
     mfprintf(fd,'   '+date()+'\n\n');
     mfprintf(fd,csvkopf+'\n');    // Spaltenberschriften 
     
     // jeden Wert einzeln umformatieren
     for i=1:len,
      for j=1:anz, 
       mfprintf(fd,'%5.3f, ',csv(i,j)); // Formatnderung
      end;
      mfprintf(fd,'\n');      // Zeilen-Ende
     end
     mclose(fd);              // csv-File schliessen

     // zurcklesen (Test):
     // matrixform=fscanfMat(csvname);
     // textform=mgetl(csvname);
     printf('\nZeitfunktionen im Excel-CSV-Format gespeichert: \n %s \n',csvname);


// INC-File fr ATtiny13 unter AVR-Studio4 bauen:
     incname = plotfile+'.inc'; 
     
     // Abtastrate reduzieren?     
     // i.a. fs = 44000 Hz    (Samplerate der *.WAV-Files)
     // avrrate = 10000;   (im *.PRA-File) 10kHz ~ 1/100 s, gewnschte Rate fr inc-File
     ratio = uint16(fs/avrrate);  // Faktor der Unterabtastung auf Integer gerunded

     // Spalten auswhlen und Datenmatrix erzeugen
     incdaten = evstr(avrfunc);    // Bewerte und fhre String 'avrfunc' aus
                                   // Ergebnismatrix ist incdaten
     
      // Lnge zuschneiden
     incdaten = incdaten([1:avrleng],[1:4]); // Matrix beschnippeln auf n * 4 Elemente
     
     // Kopfzeile der Namen erstellen
     tp=tokenpos(avrfunc);
     
     i1=part(avrfunc,tp(1,2));     // Index i rausholen (String!)
     i2=part(avrfunc,tp(2,2));
     i3=part(avrfunc,tp(3,2));
     i4=part(avrfunc,tp(4,2));
     x1=str2code(i1);              // Index i konvertieren nach Integer
     x2=str2code(i2);
     x3=str2code(i3);
     x4=str2code(i4);
     j1='f'+string(x1)+' = '+f(x1);      // Form f(1), f(2), etc.
     j2='f'+string(x2)+' = '+f(x2);
     j3='f'+string(x3)+' = '+f(x3);
     j4='f'+string(x4)+' = '+f(x4);
     
     // incdaten spaltenweise auf Eins normieren
     for  i=1:4,
          // max der Spalte ermitteln
          incmax = max(incdaten(:,i));       // Doppelpunkt dient als Joker
          // Spalte (:,i) auswhlen
          incdaten(:,i) = incdaten(:,i) ./ incmax;     // Spalte (:,i) normieren
     end;
     
     // in 15 Teile (4 Bit) zerlegen (mal 16, runden)
     // incdaten = round(incdaten*255);     // Byte-Ausgabe (8 Bit)
     incdaten = round(incdaten*15);     // Nibble-Ausgabe (4 Bit)

     // INC-File anlegen
     fd=mopen(incname,'w+');  // try to open INC-File (Error: file is opened by a different application)
     mfprintf(fd,';\n; Zeitfunktionen im hexa db-Format fr AVR-Studio4 \n;\n');
     mfprintf(fd,'; Parameterfile '+ initfile +'.pra\n');
     mfprintf(fd,'; Plotfile \t'+ plotfile +'.gif\n');
     mfprintf(fd,'; Directory '+ directory +'\n');
     mfprintf(fd,'; '+ author +'\n');
     mfprintf(fd,'; '+ date()+'\n');
     mfprintf(fd,'; Anzahl der Reihen: %i\n',avrleng);
     mfprintf(fd,'; Spalten zu je ein Halbbyte: '+ avrfunc +'\n');    // Spaltenberschrift
     mfprintf(fd,';  '+ j1 +'\n');
     mfprintf(fd,';  '+ j2 +'\n');
     mfprintf(fd,';  '+ j3 +'\n');
     mfprintf(fd,';  '+ j4 +'\n\n');
     mfprintf(fd,'.cseg\n');
     mfprintf(fd,'db_daten:\n');
     mfprintf(fd,'.db ');

     // jeden Wert einzeln in hex-Format umformatieren
     backsla='\';
     for i=1:avrleng,
       // Eine hex-Zeile zusammenbasteln:
       mfprintf(fd,'0x%x%x,0x%x%x,%s',incdaten(i,1),incdaten(i,2),incdaten(i,3),incdaten(i,4),backsla); // Formatnderung auf hex 0...f
       mfprintf(fd,'\n');      // Zeilen-Ende
     end
     mfprintf(fd,'0,0');      // letzte Zeile, Abschlu
     mclose(fd);              // csv-File schliessen
          
     printf('\nZeitfunktionen  konvertiert in hex-Format 4x %g x 4bit: \n   %s, \n   %s, \n   %s, \n   %s',avrleng,j1,j2,j3,j4);
     printf('\n\ninclude-File fr AVR-Studio4 erstellt: \n %s \n',incname);
     
printf('\n================ wav2gif %s ==================\n\n',version);
printf('\n\n-->');


return;

//whos
// Tests: Kommentarzeichen entfernen
     //matrixform = fscanfMat(incname)
     //incfile = mgetl(incname);
     //size(incfile)
     //incfile



